/**
	 * Limon - Hello World
	 * 18 / 06 / 2013
	 * 
     * @langversion 3.0
     * @playerversion Flash 11.7
     * @author David Massenot (http://artcustomer.fr)
	 * @version 1.0.0.0
**/
package {
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.events.Event;
	
	import artcustomer.framework.debug.console.ConsoleLog;
	
	import artcustomer.limon.helloworld.api.LimonHelloWorld;
	
	
	/**
	 * Main
	 * 
	 * @author David Massenot
	 */
	public class Main extends Sprite {
		private var _consoleLog:ConsoleLog;
		
		private var _application:LimonHelloWorld;
		
		
		/**
		 * Constructor
		 */
		public function Main():void {
			this.addEventListener(Event.ADDED_TO_STAGE, added, false, 0, true);
			this.addEventListener(Event.REMOVED_FROM_STAGE, removed, false, 0, true);
		}
		
		/**
		 * @private
		 */
		private function added(e:Event):void {
			this.removeEventListener(Event.ADDED_TO_STAGE, added);
			
			setupConsole();
			setupApplication();
		}
		
		/**
		 * @private
		 */
		private function removed(e:Event):void {
			this.removeEventListener(Event.REMOVED_FROM_STAGE, removed);
			
			destroyApplication();
			destroyConsole();
		}
		
		//---------------------------------------------------------------------
		//  ConsoleLog
		//---------------------------------------------------------------------
		
		/**
		 * @private
		 */
		private function setupConsole():void {
			_consoleLog = ConsoleLog.getInstance();
			_consoleLog.stageReference = this.stage;
			_consoleLog.init();
			_consoleLog.add();
		}
		
		/**
		 * @private
		 */
		private function destroyConsole():void {
			if (_consoleLog) {
				_consoleLog.destroy();
				_consoleLog = null;
			}
		}
		
		//---------------------------------------------------------------------
		//  Application
		//---------------------------------------------------------------------
		
		/**
		 * @private
		 */
		private function setupApplication():void {
			_application = new LimonHelloWorld();
			_application.contextView = this;		// REQUIRED !
			_application.setup();					// REQUIRED
		}
		
		/**
		 * @private
		 */
		private function destroyApplication():void {
			if (_application) {
				_application.destroy();
				_application = null;
			}
		}
	}
}