package artcustomer.limon.helloworld.components.application {
	import artcustomer.framework.engines.component.FlashComponent;
	import artcustomer.framework.debug.console.ConsoleLog;
	
	import artcustomer.limon.helloworld.components.application.view.views.ViewApplication;
	
	
	/**
	 * CompApplication
	 * 
	 * @author David Massenot
	 */
	public class CompApplication extends FlashComponent {
		
		
		/**
		 * Constructor
		 */
		public function CompApplication() {
			super();
			this.id = 'application';
		}
		
		//---------------------------------------------------------------------
		//  Views 
		//---------------------------------------------------------------------
		
		/**
		 * @private
		 */
		private function registerDefaultViews():void {
			this.registerView(ViewApplication, 'viewApplication', true, true);
		}
		
		
		/**
		 * Entry point of the component.
		 */
		override public function build():void {
			ConsoleLog.log('Component ' + this.id + ' is builded');
			
			super.build();
			super.add();
			
			registerDefaultViews();
			
			// Send update to all views
			this.model.update('', null, null);
		}
		
		/**
		 * End point of the component.
		 */
		override public function destroy():void {
			super.destroy();
		}
	}
}