package artcustomer.limon.helloworld.components.application.command {
	import artcustomer.framework.core.*;
	import artcustomer.framework.debug.console.ConsoleLog;
	
	import artcustomer.limon.helloworld.components.application.command.macros.ApplicationMacroCommand;
	
	
	/**
	 * ApplicationCommand
	 * 
	 * @author David Massenot
	 */
	public class ApplicationCommand extends AbstractCommand implements ICommand {
		
		
		/**
		 * Constructor
		 */
		public function ApplicationCommand() {
			super();
		}
		
		//---------------------------------------------------------------------
		//  Macros 
		//---------------------------------------------------------------------
		
		/**
		 * @private
		 */
		private function registerDefaultMacros():void {
			this.registerMacro(ApplicationMacroCommand, 'applicationMacroCommand');
		}
		
		
		/**
		 * Setup ApplicationCommand.
		 */
		override public function setup():void {
			ConsoleLog.log('ApplicationCommand is created');
			
			super.setup();
			
			registerDefaultMacros();
		}
		
		/**
		 * Reset ApplicationCommand.
		 */
		override public function reset():void {
			super.reset();
		}
		
		/**
		 * Destroy ApplicationCommand.
		 */
		override public function destroy():void {
			super.destroy();
		}
	}
}